; Copyright (c) 1998-2003 A.P. Hitchcock  All rights reserved
;+
;NAME:
;	AX_RGB_MAP
;
;LAST CHANGED: ----------------------------------- 16-Jun-03
;
;PURPOSE:
;	This  widget provides tools to construct a RGB composite map from
; a set of 3 images existing in aXis2000. It allows mage selection and
; adjustment of min/max scales for each color. A color circle and
; separate R, G, B color scales can be optionally selected
;
;CATEGORY:
;  AXIS: stacks
;
; AX_RGB_MAP_EVENT ROUTINES:
;
; LIST_RGB_RED		select buffer for RED
; LIST_RGB_GREEN	select buffer for GREEN
; LIST_RGB_BLUE		select buffer for BLUE
; BUT_RGB_CIRCLE	on/off color circle display
; BUT_RGB_SCALES	on/off R, G, B scales
; SLIDER_RGB_GMAX	adjust red max value
; SLIDER_RGB_GMAX	adjust green max value
; SLIDER_RGB_GMAX	adjust blue max value
; SLIDER_RGB_GMIN	adjust red min value
; SLIDER_RGB_GMIN	adjust green min value
; SLIDER_RGB_GMIN	adjust blue min value
; TEXT_RGB_GMAX		adjust red max value
; TEXT_RGB_GMAX		adjust green max value
; TEXT_RGB_GMAX		adjust blue max value
; TEXT_RGB_GMIN		adjust red min value
; TEXT_RGB_GMIN		adjust green min value
; TEXT_RGB_GMIN		adjust blue min value
; BUT_RGB_CANCEL	cancel
; BUT_RGB_SAVE		save composite map
;
;COMMON BLOCKS:
;	@AXIS_COM	    standard set of common blocks
;	@RGB_MAP_COM	parameters specific to AX_RGB_MAP widget
;
;MODIFICATION HISTORY:
; (16-jun-03 aph) first version
;-
;
;-----------------------------------------------------------------
pro LIST_RGB_RED, Event
on_error,2
@axis_com


end

;-----------------------------------------------------------------

pro LIST_RGB_GREEN, Event
on_error,2
@axis_com

end

;-----------------------------------------------------------------

pro LIST_RGB_BLUE, Event
on_error,2
@axis_com

end

;-----------------------------------------------------------------
pro BUT_RGB_CIRCLE, Event
on_error,2
@axis_com

end

;-----------------------------------------------------------------
pro SLIDER_RGB_GMAX, Event
on_error,2
@axis_com

end

;-----------------------------------------------------------------
pro SLIDER_RGB_RMAX, Event
on_error,2
@axis_com

end

;-----------------------------------------------------------------
pro SLIDER_RGB_BMAX, Event
on_error,2
@axis_com

end

;-----------------------------------------------------------------
pro SLIDER_RGB_BMIN, Event
on_error,2
@axis_com

end

;-----------------------------------------------------------------
pro SLIDER_RGB_RMIN, Event
on_error,2
@axis_com

end

;-----------------------------------------------------------------
pro SLIDER_RGB_GMIN, Event
on_error,2
@axis_com

end

;-----------------------------------------------------------------
pro TEXT_RGB_RMIN, Event
on_error,2
@axis_com

end

;-----------------------------------------------------------------
pro TEXT_RGB_GMIN, Event
on_error,2
@axis_com

end

;-----------------------------------------------------------------
pro TEXT_RGB_BMIN, Event
on_error,2
@axis_com

end

;-----------------------------------------------------------------
pro TEXT_RGB_BMAX, Event
on_error,2
@axis_com

end

;-----------------------------------------------------------------
pro TEXT_RGB_GMAX, Event
on_error,2
@axis_com

end

;-----------------------------------------------------------------
pro TEXT_RGB_RMAX, Event

end

;-----------------------------------------------------------------
pro BUT_RBG_CANCEL, Event
on_error,2
@axis_com

WIDGET_CONTROL, Event.Top, /DESTROY
end


pro BUT_RBG_SAVE, Event
on_error,2
@axis_com

end


;
; Empty stub procedure used for autoloading.
;
pro ax_rgb_map_eventcb
end



pro RBG_BASE_event, Event
on_error,2
@axis_com

  wWidget =  Event.top

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='RBG_BASE'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_KILL_REQUEST' )then $
        LIST_RGB_BLUE, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RGB_DROPLIST_red'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_DROPLIST' )then $
        LIST_RGB_RED, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RGB_DROPLIST_green'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_DROPLIST' )then $
        LIST_RGB_GREEN, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RGB_BUTTON_scales'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        BUT_RGB_CIRCLE, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RGB_SLIDER_Gmax'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_SLIDER' )then $
        SLIDER_RGB_GMAX, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RGB_SLIDER_Rmax'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_SLIDER' )then $
        SLIDER_RGB_RMAX, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RGB_SLIDER_Bmax'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_SLIDER' )then $
        SLIDER_RGB_BMAX, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RGB_SLIDER_Bmin'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_SLIDER' )then $
        SLIDER_RGB_BMIN, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RGB_SLIDER_Rmin'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_SLIDER' )then $
        SLIDER_RGB_RMIN, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RGB_SLIDER_Gmin'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_SLIDER' )then $
        SLIDER_RGB_GMIN, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RGB_BUTTON_circle'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        BUT_RGB_CIRCLE, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RGB_TEXT_Rmin'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_TEXT_STR' )then $
        TEXT_RGB_RMIN, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RGB_TEXT_Gmin'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_TEXT_STR' )then $
        TEXT_RGB_GMIN, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RGB_TEXT_Bmin'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_TEXT_STR' )then $
        TEXT_RGB_BMIN, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RGB_TEXT_Bmax'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_TEXT_STR' )then $
        TEXT_RGB_BMAX, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RGB_TEXT_Gmax'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_TEXT_STR' )then $
        TEXT_RGB_GMAX, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RGB_TEXT_Rmax'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_TEXT_STR' )then $
        TEXT_RGB_RMAX, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RGB_BUTTON_cancel'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        BUT_RBG_CANCEL, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RGB_BUTTON_save'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        BUT_RBG_SAVE, Event
    end
    else:
  endcase

end

pro RBG_BASE, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
on_error,2
@axis_com

;----------------------- Default values (ultimately from last use of widget, stored in RGB_MAP_COM)
RGB_Rimage = 4
RGB_Gimage = 5
RGB_Bimage = 6
Label = strarr(10)
Label(0) = '0'
Label(1) = '1'
Label(2) = '2'
Label(3) = '3'
Label(4) = '4'
Label(5) = '5'
Label(6) = '6'
Label(7) = '7'
Label(8) = '8'
Label(9) = '9'


  Resolve_Routine, 'ax_rgb_map_eventcb'     ; Load event callback routines

  RBG_BASE = Widget_Base( GROUP_LEADER=wGroup, UNAME='RBG_BASE'  $
      ,SCR_XSIZE=636 ,SCR_YSIZE=466 ,/TLB_KILL_REQUEST_EVENTS  $
      ,TITLE='RGB composite map' ,SPACE=3 ,XPAD=3 ,YPAD=3)


  RGB_image = Widget_Draw(RBG_BASE, UNAME='RGB_image' ,XOFFSET=167  $
      ,SCR_XSIZE=460 ,SCR_YSIZE=360)


  RGB_DROPLIST_RED = Widget_Droplist(RBG_BASE,  $
      UNAME='RGB_DROPLIST_red' ,XOFFSET=198 ,YOFFSET=367  $
      ,SCR_XSIZE=379 ,SCR_YSIZE=26 ,TITLE='Red')
  RGB_DROPLIST_GREEN = Widget_Droplist(RBG_BASE,  $
      UNAME='RGB_DROPLIST_green' ,XOFFSET=190 ,YOFFSET=391  $
      ,SCR_XSIZE=388 ,SCR_YSIZE=26 ,TITLE='Green')
  RGB_DROPLIST_BLUE = Widget_Droplist(RBG_BASE,  $
      UNAME='RGB_DROPLIST_blue' ,XOFFSET=196 ,YOFFSET=416  $
      ,SCR_XSIZE=383 ,SCR_YSIZE=26 ,TITLE='Blue')

WIDGET_CONTROL, RGB_DROPLIST_RED,   Set_Value=Label, SET_DROPLIST_SELECT=RGB_Rimage
WIDGET_CONTROL, RGB_DROPLIST_GREEN, Set_Value=Label, SET_DROPLIST_SELECT=RGB_Gimage
WIDGET_CONTROL, RGB_DROPLIST_BLUE,  Set_Value=Label, SET_DROPLIST_SELECT=RGB_Bimage

  WID_BASE_1 = Widget_Base(RBG_BASE, UNAME='WID_BASE_1' ,XOFFSET=96  $
      ,YOFFSET=247 ,TITLE='IDL' ,COLUMN=1 ,/EXCLUSIVE)


  RGB_BUTTON_scales = Widget_Button(WID_BASE_1,  $
      UNAME='RGB_BUTTON_scales' ,/ALIGN_LEFT ,VALUE='scales')


  WID_LABEL_0 = Widget_Label(RBG_BASE, UNAME='WID_LABEL_0'  $
      ,XOFFSET=15 ,YOFFSET=9 ,SCR_XSIZE=138 ,SCR_YSIZE=18  $
      ,/ALIGN_LEFT ,VALUE='Red          Green         Blue')


  RGB_SLIDER_Gmax = Widget_Slider(RBG_BASE, UNAME='RGB_SLIDER_Gmax'  $
      ,XOFFSET=68 ,YOFFSET=47 ,SCR_XSIZE=18 ,SCR_YSIZE=75  $
      ,/SUPPRESS_VALUE ,/VERTICAL)


  RGB_SLIDER_Rmax = Widget_Slider(RBG_BASE, UNAME='RGB_SLIDER_Rmax'  $
      ,XOFFSET=18 ,YOFFSET=47 ,SCR_XSIZE=18 ,SCR_YSIZE=75  $
      ,/SUPPRESS_VALUE ,/VERTICAL)


  RGB_SLIDER_Bmax = Widget_Slider(RBG_BASE, UNAME='RGB_SLIDER_Bmax'  $
      ,XOFFSET=118 ,YOFFSET=47 ,SCR_XSIZE=18 ,SCR_YSIZE=75  $
      ,/SUPPRESS_VALUE ,/VERTICAL)


  RGB_SLIDER_Bmin = Widget_Slider(RBG_BASE, UNAME='RGB_SLIDER_Bmin'  $
      ,XOFFSET=118 ,YOFFSET=132 ,SCR_XSIZE=18 ,SCR_YSIZE=75  $
      ,/SUPPRESS_VALUE ,/VERTICAL)


  RGB_SLIDER_Rmin = Widget_Slider(RBG_BASE, UNAME='RGB_SLIDER_Rmin'  $
      ,XOFFSET=18 ,YOFFSET=132 ,SCR_XSIZE=18 ,SCR_YSIZE=75  $
      ,/SUPPRESS_VALUE ,/VERTICAL)


  RGB_SLIDER_Gmin = Widget_Slider(RBG_BASE, UNAME='RGB_SLIDER_Gmin'  $
      ,XOFFSET=68 ,YOFFSET=132 ,SCR_XSIZE=18 ,SCR_YSIZE=75  $
      ,/SUPPRESS_VALUE ,/VERTICAL)


  WID_BASE_2 = Widget_Base(RBG_BASE, UNAME='WID_BASE_2' ,XOFFSET=7  $
      ,YOFFSET=247 ,SCR_XSIZE=81 ,SCR_YSIZE=26 ,TITLE='IDL' ,COLUMN=1  $
      ,/EXCLUSIVE)


  RGB_BUTTON_circle = Widget_Button(WID_BASE_2,  $
      UNAME='RGB_BUTTON_circle' ,XOFFSET=54 ,YOFFSET=14 ,/ALIGN_LEFT  $
      ,VALUE='color circle')


  RGB_TEXT_Rmin = Widget_Text(RBG_BASE, UNAME='RGB_TEXT_Rmin'  $
      ,XOFFSET=13 ,YOFFSET=212 ,SCR_XSIZE=37 ,SCR_YSIZE=17 ,/EDITABLE  $
      ,/ALL_EVENTS ,XSIZE=20 ,YSIZE=1)


  RGB_TEXT_Gmin = Widget_Text(RBG_BASE, UNAME='RGB_TEXT_Gmin'  $
      ,XOFFSET=63 ,YOFFSET=212 ,SCR_XSIZE=38 ,SCR_YSIZE=17 ,/EDITABLE  $
      ,/ALL_EVENTS ,XSIZE=20 ,YSIZE=1)


  RGB_TEXT_Bmin = Widget_Text(RBG_BASE, UNAME='RGB_TEXT_Bmin'  $
      ,XOFFSET=113 ,YOFFSET=212 ,SCR_XSIZE=38 ,SCR_YSIZE=18  $
      ,/EDITABLE ,/ALL_EVENTS ,XSIZE=20 ,YSIZE=1)


  RGB_TEXT_Bmax = Widget_Text(RBG_BASE, UNAME='RGB_TEXT_Bmax'  $
      ,XOFFSET=113 ,YOFFSET=27 ,SCR_XSIZE=38 ,SCR_YSIZE=18 ,/EDITABLE  $
      ,/ALL_EVENTS ,XSIZE=20 ,YSIZE=1)


  RGB_TEXT_Gmax = Widget_Text(RBG_BASE, UNAME='RGB_TEXT_Gmax'  $
      ,XOFFSET=63 ,YOFFSET=27 ,SCR_XSIZE=38 ,SCR_YSIZE=17 ,/EDITABLE  $
      ,/ALL_EVENTS ,XSIZE=20 ,YSIZE=1)


  RGB_TEXT_Rmax = Widget_Text(RBG_BASE, UNAME='RGB_TEXT_Rmax'  $
      ,XOFFSET=13 ,YOFFSET=27 ,SCR_XSIZE=38 ,SCR_YSIZE=17 ,/EDITABLE  $
      ,/ALL_EVENTS ,XSIZE=20 ,YSIZE=1)


  RGB_BUTTON_cancel = Widget_Button(RBG_BASE,  $
      UNAME='RGB_BUTTON_cancel' ,XOFFSET=26 ,YOFFSET=299  $
      ,SCR_XSIZE=114 ,SCR_YSIZE=46 ,/ALIGN_CENTER ,VALUE='Cancel')


  RGB_BUTTON_save = Widget_Button(RBG_BASE, UNAME='RGB_BUTTON_save'  $
      ,XOFFSET=27 ,YOFFSET=359 ,SCR_XSIZE=114 ,SCR_YSIZE=46  $
      ,/ALIGN_CENTER ,VALUE='Save')

  Widget_Control, /REALIZE, RBG_BASE

  XManager, 'RBG_BASE', RBG_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro ax_rgb_map, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  RBG_BASE, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
on_error,2
@axis_com

end
